Has patch: No
Subject: Check the current status of i18n / L10n
Description

Subtasks:
Task # 11955: assess the current state of the I18n feature Resolved
Task # 11956: check Translate-ViewHelper in incubation state, and migrate it to fluid Resolved
Task # 11957: check how JavaScript strings can be translated Resolved
Task # 12612: Create a JavaScript localization provider / caching / service class Resolved
Related issues:
related to TYPO3.Flow - Feature # 14037: Translation files (XLIFF) must be po... Resolved 2011-03-24

History
#1 - 2011-01-06 14:19 - Sebastian Kurfuerst
- Subject changed from Improve Internationalization / Localization and get it running to (Timeboxed): Check the current status of i10n / l10n

#2 - 2011-01-06 14:22 - Sebastian Kurfuerst
- Position deleted (6)
- Position set to 4

#3 - 2011-01-19 17:47 - Sebastian Kurfuerst

Just had a quick look, generally well-structured. Some things which caught my attention:

    -  F3\FLOW3\I18n\Service should be called "LocaleService" 
    -  inside the "XliffTranslationProvider", the $xliffBasePath is hardcoded to a directory inside FLOW3 (FLOW3/Private/Locale/Translations). This
needs to  be done per-package, as each package should be allowed to provide localizations. I am not fully sure yet how this should look like; most
probably one needs to specify the current package. Inside the Translate ViewHelper, we could automatically set the current package by default.
    -  For JavaScript files, we need a possibility to retrieve all localized strings for a given locale, in order to encode them as JSON. I did not see
support for this yet.

Greets,
Sebastian

#4 - 2011-03-04 09:44 - Robert Lemke
- Position deleted (6)
- Position set to 23

#5 - 2011-03-24 22:17 - Karsten Dambekalns
- Status changed from New to Accepted
- Assigned To set to Karsten Dambekalns
Today I played around with I18n in FLOW3. My goal was to add translated labels to at least some pages of the Blog. I succeeded1, but there are still
some open ends. As was to be expected. :)

First, the Fluid TranslateViewHelper is not in the Fluid package, I pushed a change for review to include it at:
http://review.typo3.org/1262
That would resolve
http://forge.typo3.org/issues/11956

Second, I18n has to be initialized, see this change for that:
https://review.typo3.org/1238

The documentation does not tell where to put XLIFF files, and in fact the lookup is too restrictive currently. It expects files at
resource://FLOW3/Private/Locale/Translations/ - so all translation files would have to be in the FLOW3 package. That obviously does not make sense.
I created an issue for this:
http://forge.typo3.org/issues/14037

And finally we probably need a way to automatically extract translateable stuff from source (Fluid templates to begin with) and create XLIFF from it.
Translation is nicely possible with Pootle (tried that today), but creating an initial XLIFF file needs some love. If someone knows about a tool for that,
let us know!

[1] https://skitch.com/k-fish/rstf4/xliff-at-work

#6 - 2011-05-05 13:50 - Robert Lemke
- Project changed from Core Team to Base Distribution
- Target version deleted (788)

#7 - 2011-05-06 08:14 - Robert Lemke
- Target version set to 1228
- Position deleted (17869)
- Position set to 3

#8 - 2011-05-06 08:17 - Robert Lemke
- Project changed from Base Distribution to TYPO3 Flow Base Distribution
- Target version deleted (1228)

#9 - 2011-05-06 08:17 - Robert Lemke
- Target version set to 1.0 beta 1
- Position deleted (3)
- Position set to 3

#10 - 2011-05-06 10:10 - Robert Lemke
- Tracker changed from Story to Task
- Estimated time set to 0.00

#11 - 2011-05-06 10:11 - Robert Lemke
- Project changed from TYPO3 Flow Base Distribution to TYPO3.Flow
- Estimated time set to 0.00

#12 - 2011-06-09 17:41 - Rens Admiraal
- Estimated time set to 0.00
Extended I18n class to support plural / replacement values, and added comment to the XLIFF project about our suggestion for an API.

This change would actually better reflect current PHP functionality in ExtJS4
https://review.typo3.org/#change,2609

The XLIFF page: http://forge.typo3.org/projects/typo3v4-xliff/wiki/RFC_XLIFF_extjs_api

#13 - 2011-07-06 16:08 - Karsten Dambekalns
- Target version changed from 1.0 beta 1 to 1.1

#14 - 2011-11-23 13:23 - Sebastian Kurfuerst
- Estimated time set to 0.00
- Has patch set to No

Current Status:

    -  Label translation / Public API is being polished
    -  still missing: conventions for XLIFF label keys; concept for translating command line output

#15 - 2011-12-15 17:33 - Karsten Dambekalns
- Category set to I18n

#16 - 2011-12-15 17:37 - Karsten Dambekalns
- Subject changed from (Timeboxed): Check the current status of i10n / l10n to Check the current status of i18n / L10n
- Estimated time set to 0.00

#17 - 2011-12-15 17:39 - Karsten Dambekalns
- Status changed from Accepted to Resolved
- Estimated time set to 0.00

Closing this one due to bit rot setting in... :)

The state was assessed and tweaked heavily. Whatever is still missing (we'll see) should get new feature issues.

#18 - 2011-12-21 12:37 - Karsten Dambekalns
- Estimated time deleted (0.00)

#19 - 2011-12-21 12:37 - Karsten Dambekalns
- Target version changed from 1.1 to 1.1 beta 1
- Estimated time set to 0.00

2015-08-03 3/3

https://review.typo3.org/#change,2609
http://forge.typo3.org/projects/typo3v4-xliff/wiki/RFC_XLIFF_extjs_api

